#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from irc3.plugins.command import command
from irc3.plugins.cron import cron
import irc3
import random
import uuid
import os
import string
from datetime import datetime
from pytz import timezone

codes_db = os.path.dirname(os.path.realpath(__file__)) + '/../flask/challenge/codes.db'
chpin_db = os.path.dirname(os.path.realpath(__file__)) + '/../chpin.db'
chxfer_db = os.path.dirname(os.path.realpath(__file__)) + '/../chxfer.db'


NOTE="""
\x0303||====================================================================||
\x0303||//$\\\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\//$\\\||
\x0303||(\x0309xxx\x0303)================| \x0309IRCD.CHAT TCPDIRECT NOTE \x0303|==============(\x0309xxx\x0303)||
\x0303||\\\$//        ~       '--------========----------'              \\\$//||
\x0303||<< /        /$\              // ____ \\\                         \ >>||
\x0303||>>|  \x030912\x0303    //L\\\            // ///..) \\\         \x0309L00000000B   12\x0303 |<<||
\x0303||<<|        \\\ //           || <||  >\  ||                        |>>||
\x0303||>>|         \$/            ||  $$ --/  ||        \x0309PENIS PUMP\x0303      |<<||
\x0303||<<|      \x0309L00000000B\x0303        *\\\  |\_/  //* \x0309series\x0303                 |>>||
\x0303||>>|  \x030912\x0303                     *\\\/___\_//*   \x03091989\x0303                  |<<||
\x0303||<<\    \x0309IRC OPERATOR\x0303   _______/\x0309FuckHole\x0303\_________    \x0309HARDCHAT  12\x0303 />>||
\x0303||//$\                ~|\x0309IN FUCKHOLE JONES WE TRUST\x0303|~              /$\\\||
\x0303||(\x0309xxx\x0303)===================7777777777777777777777=================(\x0309xxx\x0303)||
\x0303||\\\$//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\\\$//||
\x0303||====================================================================||
"""

class D:
    pass

@irc3.plugin
class Plugin:

    def __init__(self,bot):
        self.bot=bot
        self.DENOMINATIONS = [ 1,5,10,20,50,100,500 ]
        self.VALUE_AS_WORD = [ "====  \x0309ONE DOLLAR\x0303 =====", "==== \x0309FIVE DOLLARS\x0303 ====", "===== \x0309TEN DOLLARS\x0303 ====", "=== \x0309TWENTY DOLLARS\x0303 ===", "===  \x0309FIFTY DOLLARS\x0303 ===", "  \x0309ONE HUNDRED DOLLARS\x0303 ", " \x0309FIVE HUNDRED DOLLARS\x0303 " ]
        self.OSET=string.printable[:62] #DSET=''.join(random.choices(string.printable[:62],k=62))
        self.ESET='k9isgJHO8QTCnAV7qw1hjZL5tI246GSvzoDMpyuPWRNdB3mrcxYeE0lfaFXKUb'
        bot.D0T = D()
        try:
            BINS = self.bot.db.getlist("BINS")[0]
            BILLS = self.bot.db.getlist("BILLS")
            HOLDING = self.bot.db.getlist("HOLDING")
            NOTES = self.bot.db.getlist("NOTES")
            CIRCULATION = self.bot.db.getlist("CIRCULATION")
        except:
            print('tcpbank_press')
            self.tcpbank_press(50000)

    def __emoj(self,s):
        emote_db = '%s/../emote.db' % dir_path
        emoj = random.choice(list(open(emote_db)))
        random.randint(0,1)
        if random.randint(0,1) == 0:
            emoj = "\x0304{}\x0F".format(emoj)
        else:
            emoj = "\x0303{}\x0F".format(emoj)
        s = s + ' \x02\x0303�^ֶ\x0F ' + emoj
        return s

    def closest(self, lst, K):
        return lst[min(range(len(lst)), key = lambda i: abs(lst[i]-K))]

    def tcpbank_press(self,amount):
        if amount < 1000:
            print('increments of 1000 only')
            return
        iterations = amount // 1000
        self.bot.db.setlist("BINS",[0])
        BINS = self.bot.db.getlist("BINS")[0]
        BILLS = {}
        HOLDING = {}

        for i in range(1*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 500 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(2*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 100 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(2*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 50 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 20 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 10 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 5 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(25*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 1 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        NOTES=BILLS
        self.bot.db.setlist("BILLS",[BILLS])
        self.bot.db.setlist("HOLDING",[HOLDING])
        self.bot.db.setlist("NOTES",[NOTES])

        return

    def tcpbank_circulate(self,mask,target,amount):
        try:
            BILLS = self.bot.db.getlist("BILLS")
            HOLDING = self.bot.db.getlist("HOLDING")
            NOTES = self.bot.db.getlist("NOTES")
            tcp_bank_account_index=-1
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_index = i
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        tcp_bank_account_pin = tcp_bank_accounts[0][i]['tcp_bank_account_pin']
                        tcp_bank_account_challenge = tcp_bank_accounts[0][i]['tcp_bank_account_challenge']
                        tcp_bank_account_status = tcp_bank_accounts[0][i]['tcp_bank_account_status']
            except:
                pass
            CIRCULATION = {}
            HOLDER = {}
            holder = mask.nick
            # print(amount)
            while amount != 0:
                NOTES=dict(sorted(NOTES[0].items(), key=lambda x: x[1], reverse=True))
                for i,_ in enumerate(zip(NOTES.values(),NOTES.keys())):
                    bills = set(BILLS[0].values())
                    stack = {}
                    for __ in bills:
                        count = 0
                        for ___ in BILLS[0].values():
                            if ___ == _:
                                count+=1
                        stack.update({_:count})
                    if _[0] <= amount:
                        BILLBIN=list(NOTES.keys())
                        _note = _[1]
                        _amount = _[0]
                        _holding = HOLDING[0][BILLBIN[i]]
                        _holder = holder
                        HOLDING[0].update({BILLBIN[i]:holder})
                        CIRCULATION.update({BILLBIN[i]:_[0]})
                        HOLDER.update({BILLBIN[i]:holder})
                        amount = amount - _[0]
                        msg = '{} - {} - {} -> {} >>> {}'.format(_note,_amount,_holding,_holder,amount)
                        tcp_bank_account_balance += _amount
                        self.bot.privmsg(target,msg)
                        BILLS[0].pop(BILLBIN[i])
            self.bot.db.setlist("BILLS",[BILLS])
            self.bot.db.setlist("HOLDING",[HOLDING])
            self.bot.db.setlist("NOTES",[NOTES])
            self.bot.db.setlist("CIRCULATION",[CIRCULATION])
            self.bot.db.setlist("HOLDER",[HOLDER])
            tcp_bank_accounts[0][tcp_bank_account_index]={'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_pin, 'tcp_bank_account_challenge': tcp_bank_account_challenge, 'tcp_bank_account_status': tcp_bank_account_status}
            self.bot.db.setlist("tcp_bank_accounts",tcp_bank_accounts)
            return
        except Exception as e:
            msg = f'error on circulation: {e}'
            self.bot.privmsg(target,msg)

    def tcpbank_teller(self,mask,target,bill,bin):
        note = NOTE.replace('00000000',str(bin).zfill(8))
        DENOM=-1
        for i,_ in enumerate(self.DENOMINATIONS):
            if bill == _:
                DENOM = i
                break
        if DENOM==-1: return
        note = note.replace('xxx',str(self.DENOMINATIONS[ DENOM ]).zfill(3))
        note = note.replace('7777777777777777777777',self.VALUE_AS_WORD[DENOM])

        for msg in note.splitlines():
            if not msg == "":
                self.bot.privmsg(target,msg)
        return



    def tcpbank_exchange(self,mask,target,x_amount,x_bills,x_bins,x_holders,x_new_holder):
        amount_backup = x_amount
        bills_backup = x_bills
        bins_backup = x_bins
        holders_backup = x_holders
        new_holder_backup = x_new_holder

        bills_sent=[]
        bins_sent=[]
        holders_sent=[]
        while not amount_backup == 0:
            change=0
            for i,bill in enumerate(bills_backup):
                count = amount_backup//bill
                if count > 0:
                    # print(bill)
                    amount_backup-=bill
                    bins_sent.append(bins_backup[i])
                    bills_sent.append(bills_backup[i])
                    holders_sent.append(new_holder_backup)
                    bins_backup.pop(i)
                    bills_backup.pop(i)
                    change=1
                    break
            if change==0:
                print("could not break change")
                for _ in bins_sent:
                    x_bins.append(_)
                for _ in bills_sent:
                    x_bills.append(_)
                return(1,self.closest(x_bills,x_amount),x_bills,x_bins)
        return(0,bills_sent,bins_sent,holders_sent)


    def tcpbank_xfer(self,mask,target,amount,holder,new_holder):
        try:
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_index = i
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        tcp_bank_account_pin = tcp_bank_accounts[0][i]['tcp_bank_account_pin']
                        tcp_bank_account_challenge = tcp_bank_accounts[0][i]['tcp_bank_account_challenge']
                        tcp_bank_account_status = tcp_bank_accounts[0][i]['tcp_bank_account_status']
            except:
                pass

            if amount > tcp_bank_account_balance:
                msg = f'insufficient funds: trying to send {amount} with {tcp_bank_account_balance}'
                return

            BILLS = self.bot.db.getlist("BILLS")
            HOLDER = self.bot.db.getlist("HOLDER")
            HOLDING = self.bot.db.getlist("HOLDING")
            CIRCULATION = self.bot.db.getlist("CIRCULATION")

            BILLS=dict(sorted(BILLS[0][0].items(), key=lambda x: x[0]))
            HOLDING=dict(sorted(HOLDING[0][0].items(), key=lambda x: x[0]))
            HOLDER=dict(sorted(HOLDER[0].items(), key=lambda x: x[0]))
            CIRCULATION=dict(sorted(CIRCULATION[0].items(), key=lambda x: x[0]))



            holder_list = list(HOLDER.values())
            _holder_index = []
            _circulation_bin = []
            _circulation_value = []
            for i,_ in enumerate(holder_list):
                if _ == holder:
                    _holder_index.append(i)
                    _circulation_bin.append(list(CIRCULATION.keys())[i])
                    _circulation_value.append(list(CIRCULATION.values())[i])

            x_amount=amount
            x_bills=_circulation_value
            x_bins=_circulation_bin
            x_holders=_holder_index
            x_new_holder=new_holder
            x_a,x_b,x_c,x_d = self.tcpbank_exchange(mask,target,x_amount,x_bills,x_bins,x_holders,x_new_holder)
            if x_a == 1:
                BINS_BILLS_HOLDERS = list(zip(list(zip(x_bins,x_bills)),x_holders))
                for i,_ in enumerate(BINS_BILLS_HOLDERS):
                    if _[0][1] == x_b:
                        x_bin = BINS_BILLS_HOLDERS[i][0][0]
                        x_bill = BINS_BILLS_HOLDERS[i][0][1]
                        x_holder = HOLDER[x_bin]
                        CIRCULATION.pop(x_bin)
                        k_holder=list(HOLDER.keys())
                        for ii,__ in enumerate(k_holder):
                            if __ == x_bin: x_holders.pop(ii)
                        HOLDER.pop(x_bin)
                        BILLS.update({x_bin:x_bill})
                        BILLS=dict(sorted(BILLS.items(), key=lambda x: x[0]))
                        HOLDING.update({x_bin:'!!!!!!!!'})
                        y_bills=list(BILLS.values())
                        y_bins=list(BILLS.keys())

                y_a,y_b,y_c,y_d = self.tcpbank_exchange(mask,target,x_amount,y_bills,y_bins,x_holders,x_new_holder)
                if y_a == 0:
                    for ii,__ in enumerate(y_b):
                        CIRCULATION.update({y_c[ii]:y_b[ii]})
                        CIRCULATION=dict(sorted(CIRCULATION.items(), key=lambda x: x[0]))
                        HOLDING.update({y_c[ii]:y_d[ii]})
                        BILLS.pop(y_c[ii])
                        HOLDER.update({y_c[ii]:y_d[ii]})
                        HOLDER=dict(sorted(HOLDER.items(), key=lambda x: x[0]))
                    for ii in range(len(y_b)):
                        self.tcpbank_teller(mask,target,y_b[ii],y_c[ii]);print('')
                        tcp_bank_account_balance -= y_b[ii]
                z_a,z_b,z_c,z_d = self.tcpbank_exchange(mask,target,x_b-x_amount,y_bills,y_bins,x_holders,x_holder)
                if z_a == 0:
                    for ii,__ in enumerate(z_b):
                        tcp_bank_account_balance += __
                        CIRCULATION.update({z_c[ii]:z_b[ii]})
                        CIRCULATION=dict(sorted(CIRCULATION.items(), key=lambda x: x[0]))
                        HOLDING.update({z_c[ii]:z_d[ii]})
                        BILLS.pop(z_c[ii])
                        HOLDER.update({z_c[ii]:z_d[ii]})
                        HOLDER=dict(sorted(HOLDER.items(), key=lambda x: x[0]))
                tcp_bank_accounts[0][tcp_bank_account_index]={'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_pin, 'tcp_bank_account_challenge': tcp_bank_account_challenge, 'tcp_bank_account_status': tcp_bank_account_status}
                self.bot.db.setlist("tcp_bank_accounts",tcp_bank_accounts)
        except:
            msg = f'error on xfer: {e}'
            self.bot.privmsg(target,msg)

    def tcpbank_time(self):
        usa = timezone('America/Chicago')
        usa_time = datetime.now(usa)
        return usa_time.strftime('%m/%d/%Y - %H:%M:%S')

    def tcpbank_history(self,mask,target,event,x,tracker):
        old_history = self.bot.db.getlist(f"tcp_bank_{mask.nick}_history")
        if not old_history: old_history = []
        self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",[])
        new_history = []
        record = {  "time": self.tcpbank_time(),
                    "user": mask.nick,
                    "target": target,
                    "tracker": tracker,
                    "event": event }
        new_history.append(record)
        msg = f'event: {event} - target: {target} - time: {self.tcpbank_time()} - tracker: {tracker} - user: {mask.nick}'
        self.bot.privmsg(mask.nick,msg)
        history=[]
        for _ in old_history: history.append(_)
        for _ in new_history: history.append(_)
        self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",history)

    def tcpbank_account(self,mask,target,objective):
        msg = f'{mask.nick} - service: account - objective {objective}'
        self.bot.privmsg(mask.nick,msg)

        if str(objective).lower() == 'apply':
            tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")

            if not tcp_bank_accounts:
                topindex = 0
                tcp_bank_accounts = {'tcp_bank_account_number': '00000000', 'tcp_bank_account_owner': '-1', 'tcp_bank_account_balance': -1, 'tcp_bank_account_pin': '0', 'tcp_bank_account_challenge': '0', 'tcp_bank_account_status': 'offline'}
                tcp_bank_confirmations = '00000000000000000000000000000000000000000000000000000000000000'
                self.bot.db.setlist("tcp_bank_accounts",[tcp_bank_accounts])
                self.bot.db.setlist("account_creation_index",[topindex])
                self.bot.db.setlist("tcp_bank_confirmations",[tcp_bank_confirmations])
                self.bot.db.setlist("confirmations",[])
                self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",[])
            else:
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        event = 'account denied'; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_accounts[0][i]['tcp_bank_account_number']}, account owner: {tcp_bank_accounts[0][i]['tcp_bank_account_owner']}"
                        self.bot.privmsg(target,msg)
                        return

            old_tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
            new_tcp_bank_accounts = []

            account_uuid = uuid.uuid4().hex

            topindex  = self.bot.db.getlist("account_creation_index")[0]
            topindex+=1
            self.bot.db.setlist("account_creation_index",[topindex])
            tcp_bank_account_number = str(topindex).zfill(8)
            tcp_bank_account_owner = mask.nick
            tcp_bank_account_balance = 0
            tcp_bank_account_pin = '0'
            tcp_bank_account_challenge = '0'
            tcp_bank_account_status = 'offline'

            tcp_bank_account = {'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_challenge, 'tcp_bank_account_challenge': tcp_bank_account_challenge, 'tcp_bank_account_status': tcp_bank_account_status}
            new_tcp_bank_accounts.append(tcp_bank_account)
            event = 'account created '; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)

            tcp_bank_accounts = []
            for _ in old_tcp_bank_accounts: tcp_bank_accounts.append(_)
            for _ in new_tcp_bank_accounts: tcp_bank_accounts.append(_)
            self.bot.db.setlist("tcp_bank_accounts",[tcp_bank_accounts])

            for i in range(len(tcp_bank_accounts[0])):
                if(tcp_bank_accounts[i]['tcp_bank_account_owner'] == mask.nick):
                    tcp_bank_account_number = tcp_bank_accounts[i]['tcp_bank_account_number']
                    tcp_bank_account_owner = tcp_bank_accounts[i]['tcp_bank_account_owner']
                    tcp_bank_account_balance = tcp_bank_accounts[i]['tcp_bank_account_balance']
                    tcp_bank_account_pin = tcp_bank_accounts[i]['tcp_bank_account_pin']
                    tcp_bank_account_challenge = tcp_bank_accounts[i]['tcp_bank_account_challenge']
                    tcp_bank_account_status = tcp_bank_accounts[i]['tcp_bank_account_status']
                    msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_account_number}, account owner: {tcp_bank_account_owner}, account balance: {tcp_bank_account_balance}, account status: {tcp_bank_account_status}"
                    self.bot.privmsg(mask.nick,msg)
                    challenge = uuid.uuid4().hex
                    f = open(codes_db,'a')
                    f.write(f'{challenge} pin {mask.nick}\n')
                    f.close()
                    msg = f"visit http://ansibomb.com:54321/{challenge} to set your pin and complete your activation"
                    self.bot.privmsg(mask.nick,msg)

        elif str(objective).lower() == 'balance':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_account_number}, account owner: {tcp_bank_account_owner}, account balance: {tcp_bank_account_balance}"
                        self.bot.privmsg(mask.nick,msg)
                        event = 'account balance checked';self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        return
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)
            except:
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)


        elif str(objective).lower() == 'history':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_history = self.bot.db.getlist(f"tcp_bank_{mask.nick}_history")
                        for _ in tcp_bank_account_history:
                            msg = 'event: {} - target: {} - time: {} - tracker: {} - user: {}'.format(_['event'],_['target'],_['time'],_['tracker'],_['user'])
                            self.bot.privmsg(mask.nick,msg)
                        event = 'history accessed'; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        return
            except:
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)

        elif str(objective).lower() == 'debug':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        self.tcpbank_circulate(mask,target,10000)
                        return
            except:
                msg = 'debug finished'
                self.bot.privmsg(target,msg)

        return

    def tcpbank_money(self,mask,target,objective,amount,receiver):
        msg = f'{mask.nick} - service: money - objective: {objective} - amount: {amount} - receiver: {receiver}'
        self.bot.privmsg(mask.nick,msg)
        if objective == 'wire':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        if amount > tcp_bank_account_balance:
                             msg = f'insufficient funds: trying to send {amount} with {tcp_bank_account_balance}'
                             self.bot.privmsg(mask.nick,msg)
                             return
            except:
                msg = 'error on money gateway interface'
                self.bot.privmsg(mask.nick,msg)
                return

            challenge = uuid.uuid4().hex
            f = open(codes_db,'a')
            f.write(f'{challenge} xfer {mask.nick}\n')
            f.close()
            self.bot.xfer = []
            self.bot.xfer.append({'nick':mask.nick,'challenge':challenge,'amount':amount,'receiver':receiver,'mask':mask,'target':target})
            msg = f"visit http://ansibomb.com:54321/{challenge} to confirm your transfer with your pin"
            self.bot.privmsg(mask.nick,msg)
            __ircnick = mask.nick
            self.bot.tcpbank_xfer = self.tcpbank_xfer
            #self.tcpbank_xfer(mask,target,amount,mask.nick,receiver)
            return

    @command(permission='admin')
    def tcpbank(self, mask, target, args):
        """tcpbank services: account, money. objectives: account-apply,balance,history. money-wire.
            %%tcpbank [<service>] [<objective>] [<amount>] [<receiver>]
        """
        for _ in self.bot.phuq.USER:
            if mask.nick.lower() == _:
                print(f'{mask.nick} denied using tcpbank plugins')
                return

        services = [ 'account', 'money' ]
        try:
            service = args.get("<service>")
            if service == "":
                msg = f'hello {mask.nick}, services are account, money, lottery & loan. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                service = service.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, services are account, money, lottery & loan. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        objective_account = [ 'apply', 'history', 'balance' ]
        #objective_account = [ 'apply', 'history', 'balance', 'debug' ]        
        try:
            objective = args.get("<objective>")
            if objective == "":
                msg = f'hello {mask.nick}, objectives for account service are apply,history,balance,pin. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                objective = objective.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, objectives for account service are apply,history,balance,pin. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        objective_money = [ 'wire' ]
        try:
            objective = args.get("<objective>")
            if objective == "":
                msg = f'hello {mask.nick}, objectives for money service are wire,invest,donate. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                objective = objective.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, objectives for money service are wire,invest,donate. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        for _ in services:
            print(_)
            if _ == service:
                if service == 'account':
                    for __ in objective_account:
                        if __ == objective:
                            self.tcpbank_account(mask,target,objective)
                elif service == 'money':
                    for __ in objective_money:
                        if __ == objective:
                            try:
                                amount = int(args.get("<amount>"))
                            except Exception as e:
                                msg = f'error parsing amount command: {e}'
                                self.bot.privmsg(target,msg)
                            try:
                                receiver = str(args.get("<receiver>")).lower()
                            except Exception as e:
                                msg = f'error parsing receiver command: {e}'
                                self.bot.privmsg(target,msg)

                            self.tcpbank_money(mask,target,objective,amount,receiver)
                            return

@cron('* * * * *')
def tcpbank_callback(bot):
    ircnick = ''
    f = open(chpin_db,'r')
    l = f.read().splitlines()
    f.close()
    ll = []
    for _ in l:
        if len(l) > 0:
            tcp_bank_accounts = bot.db.getlist("tcp_bank_accounts")
            for __ in tcp_bank_accounts[0][1]['tcp_bank_account_owner']:
                ircnick = __
                if __ == _.split()[0]:
                    tcp_bank_accounts[0][1]['tcp_bank_account_pin'] = _.split()[1]
                    tcp_bank_accounts[0][1]['tcp_bank_account_challenge'] = _.split()[2]
                    tcp_bank_accounts[0][1]['tcp_bank_account_status'] = 'online'
                    bot.db.setlist("tcp_bank_accounts",tcp_bank_accounts)
                    msg = 'account activated'
                    bot.privmsg(ircnick,msg)
                else:
                    ll.append(_)
    f = open(chpin_db,'w')
    for _ in ll:
        f.write('{}\n'.format(_))
    f.close()




    ircnick = ''
    f = open(chxfer_db,'r')
    l = f.read().splitlines()
    f.close()
    ll = []
    pin_ok=0
    challenge_ok=0
    for _ in l:
        if len(l) > 0:
            tcp_bank_accounts = bot.db.getlist("tcp_bank_accounts")
            for __ in tcp_bank_accounts[0][1]['tcp_bank_account_owner']:
                ircnick = __
                if __ == _.split()[0]:
                    check_pin = _.split()[1] #tcp_bank_accounts[0][1]['tcp_bank_account_pin']
                    check_challenge = _.split()[2] #tcp_bank_accounts[0][1]['tcp_bank_account_challenge']
                    if check_pin == tcp_bank_accounts[0][1]['tcp_bank_account_pin']:
                        pin_ok = 1
                    if check_challenge == tcp_bank_accounts[0][1]['tcp_bank_account_challenge']:
                        challenge_ok = 1
                    #bot.xfer.append({'nick':mask.nick,'challenge':challenge,'amount':amount,'receiver':receiver,'mask':mask,'target':target})
                    __mask = bot.xfer[0]['mask']
                    __target = bot.xfer[0]['target']
                    __challenge = bot.xfer[0]['challenge']
                    __amount = bot.xfer[0]['amount']
                    __receiver = bot.xfer[0]['receiver']
                    bot.tcpbank_xfer(__mask,__target,__amount,ircnick,__receiver)
                else:
                    ll.append(_)
    f = open(chxfer_db,'w')
    for _ in ll:
        f.write('{}\n'.format(_))
    f.close()
