#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from irc3.plugins.command import command
from irc3.plugins.cron import cron
import irc3
import random
import uuid
import os
import string
from datetime import datetime
from pytz import timezone
import ipdb
codes_db = os.path.dirname(os.path.realpath(__file__)) + '/../flask/challenge/codes.db'
chpin_db = os.path.dirname(os.path.realpath(__file__)) + '/../chpin.db'

NOTE="""
||====================================================================||
||//$\\\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\//$\\\||
||(xxx)================| IRCD.CHAT TCPDIRECT NOTE |==============(xxx)||
||\\\$//        ~       '--------========----------'              \\\$//||
||<< /        /$\              // ____ \\\                         \ >>||
||>>|  12    //L\\\            // ///..) \\\         L00000000B   12 |<<||
||<<|        \\\ //           || <||  >\  ||                        |>>||
||>>|         \$/            ||  $$ --/  ||        PENIS PUMP      |<<||
||<<|      L00000000B        *\\\  |\_/  //* series                 |>>||
||>>|  12                     *\\\/___\_//*   1989                  |<<||
||<<\    IRC OPERATOR   _______/FuckHole\_________    HARDCHAT  12 />>||
||//$\                ~|IN FUCKHOLE JONES WE TRUST|~              /$\\\||
||(xxx)===================7777777777777777777777=================(xxx)||
||\\\$//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\\\$//||
||====================================================================||
"""


@irc3.plugin
class Plugin:

    def __init__(self,bot):
        self.bot=bot
        self.DENOMINATIONS = [ 1,5,10,20,50,100,500 ]
        self.VALUE_AS_WORD = [ "====  ONE DOLLAR =====", "==== FIVE DOLLARS ====", "===== TEN DOLLARS ====", "=== TWENTY DOLLARS ===", "===  FIFTY DOLLARS ===", "  ONE HUNDRED DOLLARS ", " FIVE HUNDRED DOLLARS " ]
        self.OSET=string.printable[:62] #DSET=''.join(random.choices(string.printable[:62],k=62))
        self.ESET='k9isgJHO8QTCnAV7qw1hjZL5tI246GSvzoDMpyuPWRNdB3mrcxYeE0lfaFXKUb'
        #tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
        #ipdb.set_trace()        
        try:
            BINS = self.bot.db.getlist("BINS")[0]
            BILLS = self.bot.db.getlist("BILLS")
            HOLDING = self.bot.db.getlist("HOLDING")
            NOTES = self.bot.db.getlist("NOTES")
            CIRCULATION = self.bot.db.getlist("CIRCULATION")
        except:
            print('tcpbank_press')
            self.tcpbank_press(10000)
            # tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
            # if not tcp_bank_accounts:
            #     topindex = 0
            #     tcp_bank_accounts = {'tcp_bank_account_number': '00000000', 'tcp_bank_account_owner': '-1', 'tcp_bank_account_balance': -1, 'tcp_bank_account_pin': '0', 'tcp_bank_account_challenge': '0', 'tcp_bank_account_status': 'offline'}
            #     tcp_bank_confirmations = '00000000000000000000000000000000000000000000000000000000000000'
            #     self.bot.db.setlist("tcp_bank_accounts",[tcp_bank_accounts])
            #     self.bot.db.setlist("account_creation_index",[topindex])
            #     self.bot.db.setlist("tcp_bank_confirmations",[tcp_bank_confirmations])
            #     self.bot.db.setlist("confirmations",[])
            #     self.bot.db.setlist(f"tcp_bank_-1_history",[])
            #     self.bot.db.setlist(f"tcp_bank_-1_dispute",[])
            #     topindex+=1
            #     self.bot.db.setlist("account_creation_index",[topindex])
            #     #decoded = D()
            #     #decoded.nick = 'd'
            #     #event = 'account created '; self.tcpbank_history(decoded,"#b0ts3x",event,0,uuid.uuid4().hex)
            #     self.bot.db.setlist("tcp_bank_accounts",[{'tcp_bank_account_balance': 0, 'tcp_bank_account_challenge': '718a628a', 'tcp_bank_account_number': '00000001', 'tcp_bank_account_owner': 'd', 'tcp_bank_account_pin': '12341234', 'tcp_bank_account_status': 'online'}])
        # ipdb.set_trace()

    def __emoj(self,s):
        emote_db = '%s/../emote.db' % dir_path
        emoj = random.choice(list(open(emote_db)))
        random.randint(0,1)
        if random.randint(0,1) == 0:
            emoj = "\x0304{}\x0F".format(emoj)
        else:
            emoj = "\x0303{}\x0F".format(emoj)
        s = s + ' \x02\x0303�^ֶ\x0F ' + emoj
        return s

    def closest(self, lst, K):
        return lst[min(range(len(lst)), key = lambda i: abs(lst[i]-K))]

    def tcpbank_press(self,amount):
        if amount < 1000:
            print('increments of 1000 only')
            return
        iterations = amount // 1000
        self.bot.db.setlist("BINS",[0])
        BINS = self.bot.db.getlist("BINS")[0]
        BILLS = {}
        HOLDING = {}

        for i in range(1*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 500 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(2*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 100 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(2*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 50 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 20 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 10 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(5*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 5 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        for i in range(25*iterations):
            BINS += 1
            BILLS.update({ str(BINS).zfill(8): 1 })
            HOLDING.update({ str(BINS).zfill(8): '!!!!!!!!' })
        NOTES=BILLS
        self.bot.db.setlist("BILLS",[BILLS])
        self.bot.db.setlist("HOLDING",[HOLDING])
        self.bot.db.setlist("NOTES",[NOTES])

        return

    def tcpbank_circulate(self,mask,target,amount):
        try:
            BILLS = self.bot.db.getlist("BILLS")
            HOLDING = self.bot.db.getlist("HOLDING")
            NOTES = self.bot.db.getlist("NOTES")
            tcp_bank_account_index=-1
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_index = i
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        tcp_bank_account_pin = tcp_bank_accounts[0][i]['tcp_bank_account_pin']
                        tcp_bank_account_challenge = tcp_bank_accounts[0][i]['tcp_bank_account_challenge']
                        tcp_bank_account_status = tcp_bank_accounts[0][i]['tcp_bank_account_status']
            except:
                pass
            CIRCULATION = {}
            HOLDER = {}
            holder = mask.nick
            # print(amount)
            while amount != 0:
                NOTES=dict(sorted(NOTES[0].items(), key=lambda x: x[1], reverse=True))
                for i,_ in enumerate(zip(NOTES.values(),NOTES.keys())):
                    bills = set(BILLS[0].values())
                    stack = {}
                    for __ in bills:
                        count = 0
                        for ___ in BILLS[0].values():
                            if ___ == _:
                                count+=1
                        stack.update({_:count})
                    if _[0] <= amount:
                        BILLBIN=list(NOTES.keys())
                        _note = _[1]
                        _amount = _[0]
                        _holding = HOLDING[0][BILLBIN[i]]
                        _holder = holder
                        HOLDING[0].update({BILLBIN[i]:holder})
                        CIRCULATION.update({BILLBIN[i]:_[0]})
                        HOLDER.update({BILLBIN[i]:holder})
                        amount = amount - _[0]
                        msg = '{} - {} - {} -> {} >>> {}'.format(_note,_amount,_holding,_holder,amount) 
                        tcp_bank_account_balance += _amount
                        self.bot.privmsg(target,msg)
                        BILLS[0].pop(BILLBIN[i])
            self.bot.db.setlist("BILLS",[BILLS])
            self.bot.db.setlist("HOLDING",[HOLDING])
            self.bot.db.setlist("NOTES",[NOTES])
            self.bot.db.setlist("CIRCULATION",[CIRCULATION])
            self.bot.db.setlist("HOLDER",[HOLDER])
            tcp_bank_accounts[0][tcp_bank_account_index]={'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_pin, 'tcp_bank_account_challenge': tcp_bank_account_challenge, 'tcp_bank_account_status': tcp_bank_account_status}                       
            self.bot.db.setlist("tcp_bank_accounts",tcp_bank_accounts)
            return
        except Exception as e:
            msg = f'error on circulation: {e}'
            self.bot.privmsg(target,msg)


    def tcpbank_confirmation_generator(self):
        confirmation = list(dict(zip(string.printable,range(62))).keys())
        random.shuffle(confirmation)
        return dict(zip(''.join(confirmation),range(62)))

    def tcpbank_inter_institution_transfer(self,mask,tcp_from,tcp_amount_to_send,tcp_to):
        tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
        if not tcp_bank_accounts:
            tcp_bank_accounts = []
            self.bot.db.setlist("accounts",[])
            self.bot.db.setlist("account_creation_index",[])
            topindex = { "topindex": 0 }
            self.bot.db.setlist("account_creation_index",topindex)
        tcp_bank_confirmations = self.bot.db.getlist("tcp_bank_confirmations")
        if not tcp_bank_confirmations:
            tcp_bank_confirmations = []
            self.bot.db.setlist("confirmations",[])
        tcp_bank_account = ''
        TRAP=0
        for i in range(len(tcp_bank_accounts)):
            if(tcp_bank_accounts[i]['user'] == mask.nick):
                TRAP=1
                if mask.nick == tcp_from:
                    tcp_bank_account_number = tcp_bank_accounts[i]['number']
                    tcp_bank_account_owner = tcp_bank_accounts[i]['owner']
                    tcp_bank_account_balance = tcp_bank_accounts[i]['balance']
                    if tcp_bank_account_balance >= tcp_amount_to_send:
                        tcp_bank_account_balance-=tcp_amount_to_send
                    record_from = {"number": tcp_bank_account_number, "owner": tcp_bank_account_owner, "balance": tcp_bank_account_balance }
                    tcp_bank_transfer_confirmation_from = tcpbank_confirmation_generator()
                    for ii in range(len(tcp_bank_accounts)):
                         if(tcp_bank_accounts[i]['user'] == tcp_from):
                            tcp_bank_account_number = tcp_bank_accounts[ii]['number']
                            tcp_bank_account_owner = tcp_bank_accounts[ii]['owner']
                            tcp_bank_account_balance = tcp_bank_accounts[ii]['balance']
                            tcp_bank_account_balance+=tcp_amount_to_send
                    record_to = {"number": tcp_bank_account_number, "owner": tcp_bank_account_owner, "balance": tcp_bank_account_balance }
                    tcp_bank_transfer_confirmation_to = tcpbank_confirmation_generator()
                    ASET=''; BSET=''; CSET=''; DSET=''; FSET='';
                    for i,_ in enumerate(ESET): ASET=ASET+string.printable[dict(zip(tcp_bank_transfer_confirmation_from,list(range(62))))[_]]
                    for i,_ in enumerate(ESET): BSET=BSET+string.printable[dict(zip(tcp_bank_transfer_confirmation_to,list(range(62))))[_]]
                    for i,_ in enumerate(ASET): CSET=CSET+BSET[dict(zip(tcp_bank_transfer_confirmation_to,list(range(62))))[_]]
                    for i,_ in enumerate(BSET): DSET=DSET+ASET[dict(zip(tcp_bank_transfer_confirmation_from,list(range(62))))[_]]
                    for i,_ in enumerate(ESET): FSET=FSET+string.printable[dict(zip(DSET,list(range(62))))[_]]
                    confirmation = { 'confirmation': fset, 'from': tcp_from, 'to': tcp_to, 'amount': tcp_amount_to_send }
                    self.bot.db.setlist("tcp_bank_accounts",record_from)
                    self.bot.db.setlist("tcp_bank_accounts",record_to)
                    tcp_bank_confirmations.append(confirmation)
                    self.bot.db.setlist("tcp_bank_confirmations",tcp_bank_confirmations)

        if TRAP==0:
            self.bot.db.setlist("accounts",tcp_bank_accounts)
            account_uuid = uuid.uuid4().hex
            for i in range(len(tcp_bank_accounts)):
                topindex = self.bot.db.getlist("account_creation_index")
                topindex+=1
                self.bot.db.setlist("account_creation_index",topindex)
                tcp_bank_account_number = str(topindex).zfill(8)
                tcp_bank_account_owner = mask.nick
                tcp_bank_account_balance = 0
                tcp_bank_account_pin = -1
                tcp_bank_account = { 'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_pin }
                self.bot.db.setlist("tcp_bank_accounts",tcp_bank_account)

    # from datetime import datetime
    # from pytz import timezone
    def tcpbank_time(self):
        usa = timezone('America/Chicago')
        usa_time = datetime.now(usa)
        return usa_time.strftime('%m/%d/%Y - %H:%M:%S')

    def tcpbank_history(self,mask,target,event,x,tracker):
        old_history = self.bot.db.getlist(f"tcp_bank_{mask.nick}_history")
        if not old_history: old_history = []
        self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",[])
        new_history = []
        record = {  "time": self.tcpbank_time(),
                    "user": mask.nick,
                    "target": target,
                    "tracker": tracker,
                    "event": event }
        new_history.append(record)
        msg = f'event: {event} - target: {target} - time: {self.tcpbank_time()} - tracker: {tracker} - user: {mask.nick}'
        self.bot.privmsg(mask.nick,msg)
        history=[]
        for _ in old_history: history.append(_)
        for _ in new_history: history.append(_)
        self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",history)

    def tcpbank_dispute(self,mask,target,event,x,tracker):
        old_dispute = self.bot.db.getlist('history')
        new_dispute = []
        tracker = uuid.uuid4().hex
        msg = f'{self.tcpbank_time()} - {mask.nick} - {target} - {tracker} - {event}'
        new_dispute.append(msg)
        self.bot.privmsg(mask.nick,msg)
        for _ in old_dispute: f"tcp_bank_{mask.nick}_dispute".append(_)
        for _ in new_dispute: f"tcp_bank_{mask.nick}_dispute".append(_)
        self.bot.db.setlist(f"tcp_bank_{mask.nick}_dispute",[f"tcp_bank_{mask.nick}_dispute"])

    def tcpbank_pin(self,mask,target,event,x,tracker):
        pin_challenge = uuid.uuid4().hex
        event = "pin challenge"
        msg = f'{self.tcpbank_time()} - {mask.nick} - {target} - {tracker} - {event}'
        self.bot.privmsg(target,msg)

    def tcpbank_account(self,mask,target,objective):
        msg = f'{mask.nick} - service: account - objective {objective}'
        self.bot.privmsg(mask.nick,msg)

        if str(objective).lower() == 'apply':
            tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")

            if not tcp_bank_accounts:
                topindex = 0
                tcp_bank_accounts = {'tcp_bank_account_number': '00000000', 'tcp_bank_account_owner': '-1', 'tcp_bank_account_balance': -1, 'tcp_bank_account_pin': '0', 'tcp_bank_account_challenge': '0', 'tcp_bank_account_status': 'offline'}
                tcp_bank_confirmations = '00000000000000000000000000000000000000000000000000000000000000'
                self.bot.db.setlist("tcp_bank_accounts",[tcp_bank_accounts])
                self.bot.db.setlist("account_creation_index",[topindex])
                self.bot.db.setlist("tcp_bank_confirmations",[tcp_bank_confirmations])
                self.bot.db.setlist("confirmations",[])
                self.bot.db.setlist(f"tcp_bank_{mask.nick}_history",[])
                self.bot.db.setlist(f"tcp_bank_{mask.nick}_dispute",[])
            else:
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        event = 'account denied'; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_accounts[0][i]['tcp_bank_account_number']}, account owner: {tcp_bank_accounts[0][i]['tcp_bank_account_owner']}"
                        self.bot.privmsg(target,msg)
                        return

            old_tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
            new_tcp_bank_accounts = []

            account_uuid = uuid.uuid4().hex

            topindex  = self.bot.db.getlist("account_creation_index")[0]
            topindex+=1
            self.bot.db.setlist("account_creation_index",[topindex])
            tcp_bank_account_number = str(topindex).zfill(8)
            tcp_bank_account_owner = mask.nick
            tcp_bank_account_balance = 0
            tcp_bank_account_pin = '0'
            tcp_bank_account_challenge = '0'
            tcp_bank_account_status = 'offline'

            tcp_bank_account = {'tcp_bank_account_number': tcp_bank_account_number, 'tcp_bank_account_owner': tcp_bank_account_owner, 'tcp_bank_account_balance': tcp_bank_account_balance, 'tcp_bank_account_pin': tcp_bank_account_challenge, 'tcp_bank_account_challenge': tcp_bank_account_challenge, 'tcp_bank_account_status': tcp_bank_account_status}
            new_tcp_bank_accounts.append(tcp_bank_account)
            event = 'account created '; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)

            tcp_bank_accounts = []
            for _ in old_tcp_bank_accounts: tcp_bank_accounts.append(_)
            for _ in new_tcp_bank_accounts: tcp_bank_accounts.append(_)
            self.bot.db.setlist("tcp_bank_accounts",[tcp_bank_accounts])

            for i in range(len(tcp_bank_accounts[0])):
                if(tcp_bank_accounts[i]['tcp_bank_account_owner'] == mask.nick):
                    tcp_bank_account_number = tcp_bank_accounts[i]['tcp_bank_account_number']
                    tcp_bank_account_owner = tcp_bank_accounts[i]['tcp_bank_account_owner']
                    tcp_bank_account_balance = tcp_bank_accounts[i]['tcp_bank_account_balance']
                    tcp_bank_account_pin = tcp_bank_accounts[i]['tcp_bank_account_pin']
                    tcp_bank_account_challenge = tcp_bank_accounts[i]['tcp_bank_account_challenge']
                    tcp_bank_account_status = tcp_bank_accounts[i]['tcp_bank_account_status']
                    msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_account_number}, account owner: {tcp_bank_account_owner}, account balance: {tcp_bank_account_balance}, account status: {tcp_bank_account_status}"
                    self.bot.privmsg(mask.nick,msg)
                    challenge = uuid.uuid4().hex
                    f = open(codes_db,'a')
                    f.write(f'{challenge} pin {mask.nick}\n')
                    f.close()
                    msg = f"visit http://ansibomb.com:54321/{challenge} to set your pin and complete your activation"
                    self.bot.privmsg(mask.nick,msg)

        elif str(objective).lower() == 'balance':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_number = tcp_bank_accounts[0][i]['tcp_bank_account_number']
                        tcp_bank_account_owner = tcp_bank_accounts[0][i]['tcp_bank_account_owner']
                        tcp_bank_account_balance = tcp_bank_accounts[0][i]['tcp_bank_account_balance']
                        msg = f"tcp bank account: {mask.nick} account information: account number: {tcp_bank_account_number}, account owner: {tcp_bank_account_owner}, account balance: {tcp_bank_account_balance}"
                        self.bot.privmsg(target,msg)
                        event = 'account balance checked';self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        return
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)
            except:
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)


        elif str(objective).lower() == 'history':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_history = self.bot.db.getlist(f"tcp_bank_{mask.nick}_history")
                        for _ in tcp_bank_account_history:
                            msg = 'event: {} - target: {} - time: {} - tracker: {} - user: {}'.format(_['event'],_['target'],_['time'],_['tracker'],_['user'])
                            self.bot.privmsg(target,msg)
                        event = 'history accessed'; self.tcpbank_history(mask,target,event,0,uuid.uuid4().hex)
                        return
            except:
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)

        elif str(objective).lower() == 'debug':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        self.tcpbank_circulate(mask,target,5000)
                        ipdb.set_trace()
                        return
            except:
                msg = 'debug finished'
                self.bot.privmsg(target,msg)


        elif str(objective).lower() == 'dispute':
            try:
                tcp_bank_accounts = self.bot.db.getlist("tcp_bank_accounts")
                for i in range(len(tcp_bank_accounts[0])):
                    if(tcp_bank_accounts[0][i]['tcp_bank_account_owner'] == mask.nick):
                        tcp_bank_account_dispute = self.bot.db.getlist(f"tcp_bank_{mask.nick}_dispute")
                        for _ in tcp_bank_account_dispute:
                            self.bot.privmsg(target,_)
                        event = 'open disputed created'; self.tcpbank_dispute(mask,target,event,0,uuid.uuid4().hex)
                        return
            except:
                msg = f"tcp bank account: {mask.nick} no account on file. feel free to apply today ?tcpbank account apply"
                self.bot.privmsg(target,msg)

        elif str(objective).lower() == 'pin':
            for i in range(len(tcp_bank_accounts)):
                if(tcp_bank_accounts[i]['user'] == mask.nick):
                    event = 'pin being changed'; self.tcpbank_pin(mask,target,event,0,uuid.uuid4().hex)
                    return



        return

    def tcpbank_money(self,mask,target,objective,amount,receiver):
        ipdb.trace()
        msg = f'{mask.nick} - service: money - objective: {objective} - amount: {amount} - receiver: {receiver}'
        self.bot.privmsg(target,msg)
        return

    def tcpbank_lottery(self,mask,target,objective):
        msg = f'{mask.nick} - service: lottery - objective: {objective}'
        self.bot.privmsg(target,msg)
        return

    def tcpbank_loan(self,mask,target,objective):
        msg = f'{mask.nick} - service: loan - objective: {objective}'
        self.bot.privmsg(target,msg)
        return


    def tcpbank_teller(self,amount):
        keys=list(dict(zip(string.printable,range(62))).keys()); random.shuffle(keys); print(keys)
        self.BINS += 1
        note = NOTE.replace('00000000',str(self.BINS).zfill(8))
        DENOM = random.randint(0,len(self.DENOMINATIONS)-1)
        note = note.replace('xxx',str(self.DENOMINATIONS[ DENOM ]).zfill(3))
        note = note.replace('7777777777777777777777',self.VALUE_AS_WORD[DENOM])

        for msg in note.splitlines():
           if not msg == "":
               self.bot.privmsg(target,msg)

    @command(permission='admin')
    def tcpbank(self, mask, target, args):
        """tcpbank services: account, money. objectives: account-apply,balance,history,dispute. money-wire.
            %%tcpbank [<service>] [<objective>] [<amount>] [<receiver>]
        """
        #tcpbank services: account, money, lottery, loan. objectives: account-apply,balance,pin,history,dispute. money-wire,invest,donate. lottery-info,events,purchase,history. loan-info,apply
        for _ in self.bot.phuq.USER:
            if mask.nick.lower() == _:
                print(f'{mask.nick} denied using tcpbank plugins')
                return

        #services = [ 'account', 'money', 'lottery', 'loan' ]
        services = [ 'account', 'money' ]
        try:
            service = args.get("<service>")
            if service == "":
                msg = f'hello {mask.nick}, services are account, money, lottery & loan. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                service = service.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, services are account, money, lottery & loan. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        #objective_account = [ 'apply', 'history', 'balance', 'dispute', 'pin' ]
        objective_account = [ 'apply', 'history', 'balance', 'debug' ]
        try:
            objective = args.get("<objective>")
            if objective == "":
                msg = f'hello {mask.nick}, objectives for account service are apply,history,balance,dispute,pin. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                objective = objective.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, objectives for account service are apply,history,balance,dispute,pin. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        #objective_money = [ 'wire', 'invest', 'donate' ]
        objective_money = [ 'wire' ]
        try:
            objective = args.get("<objective>")
            if objective == "":
                msg = f'hello {mask.nick}, objectives for money service are wire,invest,donate. service/objective example: feel free to apply today: ?tcpbank account apply'
                self.bot.privmsg(mask.nick,msg)
                return
            else:
                objective = objective.lower()

        except Exception as e:
            msg = f'hello {mask.nick}, objectives for money service are wire,invest,donate. service/objective example: feel free to apply today: ?tcpbank account apply'
            self.bot.privmsg(mask.nick,msg)
            return

        #objective_lottery = [ 'info', 'events', 'purchase', 'history' ]
        # objective_lottery = []
        # try:
        #     objective = args.get("<objective>")
        #     if objective == "":
        #         msg = f'hello {mask.nick}, objectives for lottery service are info, events, purchase & history. service/objective example: feel free to apply today: ?tcpbank account apply'
        #         self.bot.privmsg(mask.nick,msg)
        #         return
        #     else:
        #         objective = objective.lower()

        # except Exception as e:
        #     msg = f'hello {mask.nick}, objectives for lottery service are info, events, purchase & history. service/objective example: feel free to apply today: ?tcpbank account apply'
        #     self.bot.privmsg(mask.nick,msg)
        #     return

        #objective_loan = [ 'info', 'apply' ]
        # objective_loan = []
        # try:
        #     objective = args.get("<objective>")
        #     if objective == "":
        #         msg = f'hello {mask.nick}, objectives for loan service are apply and info. service/objective example: feel free to apply today: ?tcpbank account apply'
        #         self.bot.privmsg(mask.nick,msg)
        #         return
        #     else:
        #         objective = objective.lower()

        # except Exception as e:
        #     msg = f'hello {mask.nick}, objectives for loan service are apply and info. service/objective example: feel free to apply today: ?tcpbank account apply'
        #     self.bot.privmsg(mask.nick,msg)
        #     return

        try:
            for _ in services:
                ipdb.set_trace()
                print(_)
                                                # if _ == service:
                                                #     if service == 'account':
                                                #         for __ in objective_account:
                                                #             if __ == objective:
                                                #                 self.tcpbank_account(mask,target,objective)
                                                #                 return
                                                #     if service == 'money':
                                                #         ipdb.set_trace()
                                                #         for __ in objective_money:
                                                #             if __ == objective:
                                                #                 ipdb.set_trace()
                                                #                 try:
                                                #                     amount = int(args.get("<amount>"))
                                                #                 except Exception as e:
                                                #                     msg = f'error parsing amount command: {e}'
                                                #                     print(msg)

                                                #                 ipdb.set_trace()

                                                #                 try:
                                                #                     receiver = str(args.get("<receiver>")).lower()
                                                #                 except Exception as e:
                                                #                     msg = f'error parsing receiver command: {e}'
                                                #                     print(msg)


                                                #                 self.tcpbank_money(mask,target,objective,amount,receiver)
                                                #                 return
                    # if service == 'lottery':
                    #     for __ in objective_lottery:
                    #         if __ == objective:
                    #             self.tcpbank_lottery(mask,target,objective)
                    #             return
                    # if service == 'loan':
                    #     for __ in objective_loan:
                    #         if __ == objective:
                    #             self.tcpbank_loan(mask,target,objective)
                    #             return
                # else:
                    # msg = f'hello {mask.nick}, feel free to apply today: ?tcpbank account apply'
                    # self.bot.privmsg(target,msg)
                    return
        except Exception as e:
            # msg = f'hello {mask.nick}, feel free to apply today: ?tcpbank account apply'
            # self.bot.privmsg(target,msg)
            return

        #tcp_from = teller.split(' ')[0]
        #tcp_amount = teller.split(' ')[1:]
        #tcp_to = teller.split(' ')[2:]
        #status = self.tcpbank_inter_institution_transfer(tcp_from,tcp_amount,tcp_to)
        #msg = self.__emoj(status)
        #self.bot.privmsg(target,msg)

@cron('* * * * *')
def tcpbank_callback(bot):
    ircnick = ''
    f = open(chpin_db,'r')
    l = f.read().splitlines()
    f.close()
    ll = []
    for _ in l:
        if len(l) > 0:
            tcp_bank_accounts = bot.db.getlist("tcp_bank_accounts")
            for __ in tcp_bank_accounts[0][1]['tcp_bank_account_owner']:
                ircnick = __
                if __ == _.split()[0]:
                    tcp_bank_accounts[0][1]['tcp_bank_account_pin'] = _.split()[1]
                    tcp_bank_accounts[0][1]['tcp_bank_account_challenge'] = _.split()[2]
                    tcp_bank_accounts[0][1]['tcp_bank_account_status'] = 'online'
                    bot.db.setlist("tcp_bank_accounts",tcp_bank_accounts)
                    msg = 'account activated'
                    bot.privmsg(ircnick,msg)
                else:
                    ll.append(_)
    f = open(chpin_db,'w')
    for _ in ll:
        f.write('{}\n'.format(_))
    f.close()
